Summary: Matroska container manipulation utilities
Name: mkvtoolnix
Version: 28.2.0
Release: 1%{?dist}
License: GPLv2+
Source0: https://mkvtoolnix.download/sources/mkvtoolnix-%{version}.tar.xz
Source1: https://mkvtoolnix.download/sources/mkvtoolnix-%{version}.tar.xz.sig
Source2: https://mkvtoolnix.download/gpg-pub-moritzbunkus.txt
# https://github.com/mbunkus/mkvtoolnix/issues/1094
Patch0: mkvtoolnix-use-system-boost.patch
URL: https://mkvtoolnix.download/
BuildRequires: boost-devel
BuildRequires: bzip2-devel
BuildRequires: desktop-file-utils
BuildRequires: cmark-devel
BuildRequires: docbook-style-xsl
BuildRequires: file-devel
BuildRequires: flac-devel
BuildRequires: devtoolset-7-gcc-c++
BuildRequires: gettext
BuildRequires: gnupg2
BuildRequires: gtest-devel
BuildRequires: json-devel
BuildRequires: libappstream-glib
BuildRequires: libcurl-devel
BuildRequires: libebml-devel
BuildRequires: libmatroska-devel >= 1.3.5
BuildRequires: libvorbis-devel >= 1.4.8
BuildRequires: lzo-devel
%ifnarch ppc64
# https://bugzilla.redhat.com/show_bug.cgi?id=1497544
BuildRequires: po4a
%endif
BuildRequires: pcre-devel
BuildRequires: pkgconfig(Qt5Multimedia)
BuildRequires: pugixml-devel
BuildRequires: qt5-qtbase-devel
BuildRequires: rubygem-drake
BuildRequires: rubygem-json
BuildRequires: utf8cpp-devel
BuildRequires: zlib-devel
BuildRequires: %{_bindir}/xsltproc
Requires: libebml%{_isa} >= 1.3.5
Requires: libmatroska%{_isa} >= 1.4.8
Requires: oxygen-sound-theme
# bundles a modified avilib
Provides: bundled(avilib) = 0.6.10
# https://www.bunkus.org/videotools/librmff/index.html
Provides: bundled(librmff) = 0.6.0

%description
Mkvtoolnix is a set of utilities to mux and demux audio, video and subtitle
streams into and from Matroska containers.

%package gui
Summary: QT Graphical interface for Matroska container manipulation
Requires: %{name} = %{version}-%{release}
Requires: hicolor-icon-theme

%description gui
Mkvtoolnix is a set of utilities to mux and demux audio, video and subtitle
streams into and from Matroska containers.

This package contains the QT graphical interface for these utilities.

%prep
gpg2 --import --import-options import-minimal --no-default-keyring --keyring ./gpg-keyring.gpg %{S:2}
gpgv2 --keyring ./gpg-keyring.gpg %{S:1} %{S:0}
%setup -q
%patch0 -p1 -b .boost
rm -rf lib/{boost,libebml,libmatroska,nlohmann-json,pugixml,utf8-cpp}
rm -rf rake.d/vendor drake

%build
. /opt/rh/devtoolset-7/enable
%configure \
  --disable-optimization \
  --disable-update-check \
  --with-boost-libdir=%{_libdir} \
  --with-tools \
  || cat config.log
drake %{?_smp_mflags} V=1

%install
drake DESTDIR=$RPM_BUILD_ROOT TOOLS=1 install
desktop-file-validate %{buildroot}%{_datadir}/applications/org.bunkus.mkvtoolnix-gui.desktop
install -dm0755 %{buildroot}%{_metainfodir}
mv %{buildroot}{%{_datadir}/metainfo,%{_metainfodir}}/org.bunkus.mkvtoolnix-gui.appdata.xml
# https://bugzilla.redhat.com/show_bug.cgi?id=1636955
#appstream-util validate-relax --nonet %{buildroot}%{_metainfodir}/org.bunkus.mkvtoolnix-gui.appdata.xml

install -pm 755 src/tools/{base64tool,diracparser,ebml_validator,vc1parser} $RPM_BUILD_ROOT%{_bindir}

rm %{buildroot}%{_datadir}/%{name}/sounds/finished-{1,2,3}.ogg
ln -s ../../sounds/Oxygen-K3B-Insert-Medium.ogg  %{buildroot}%{_datadir}/%{name}/sounds/finished-1.ogg
ln -s ../../sounds/Oxygen-K3B-Finish-Success.ogg %{buildroot}%{_datadir}/%{name}/sounds/finished-2.ogg
ln -s ../../sounds/Oxygen-K3B-Finish-Error.ogg   %{buildroot}%{_datadir}/%{name}/sounds/finished-3.ogg

%find_lang %{name}
%ifnarch ppc64
%find_lang mkvextract --with-man
%find_lang mkvmerge --with-man
%find_lang mkvpropedit --with-man
%find_lang mkvinfo --with-man
cat mkv{extract,info,merge,propedit}.lang >> mkvtoolnix.lang

%find_lang mkvtoolnix-gui --with-man
%else
echo -n > mkvtoolnix-gui.lang
%endif

%post gui
update-desktop-database &>/dev/null || :
touch --no-create %{_datadir}/icons/hicolor &>/dev/null
touch --no-create %{_datadir}/mime/packages &> /dev/null || :

%postun gui
update-desktop-database &>/dev/null || :
if [ $1 -eq 0 ]; then
touch --no-create %{_datadir}/icons/hicolor &>/dev/null
gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
touch --no-create %{_datadir}/mime/packages &> /dev/null || :
update-mime-database %{?fedora:-n} %{_datadir}/mime &> /dev/null || :
fi

%posttrans gui
gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
update-mime-database %{?fedora:-n} %{_datadir}/mime &> /dev/null || :

%check
drake tests:run_unit

%files -f %{name}.lang
%license COPYING
%doc AUTHORS README.md
%{_bindir}/base64tool
%{_bindir}/diracparser
%{_bindir}/ebml_validator
%{_bindir}/mkvextract
%{_bindir}/mkvinfo
%{_bindir}/mkvmerge
%{_bindir}/mkvpropedit
%{_bindir}/vc1parser
%{_mandir}/man1/mkvextract.1*
%{_mandir}/man1/mkvinfo.1*
%{_mandir}/man1/mkvmerge.1*
%{_mandir}/man1/mkvpropedit.1*

%files gui -f mkvtoolnix-gui.lang
%{_bindir}/mkvtoolnix-gui
%{_mandir}/man1/mkvtoolnix-gui.1*
%{_datadir}/applications/org.bunkus.mkvtoolnix-gui.desktop
%{_metainfodir}/org.bunkus.mkvtoolnix-gui.appdata.xml
%{_datadir}/icons/hicolor/*/apps/*.png
%{_datadir}/mime/packages/org.bunkus.mkvtoolnix-gui.xml
%{_datadir}/mkvtoolnix

%changelog
* Tue Oct 30 2018 Dominik Mierzejewski <rpm@greysector.net> - 28.2.0-1
- update to 28.2.0
- fixes CVE-2018-4022 (#1644258)
- unbundle sound files from oxygen sound theme

* Mon Oct 08 2018 Dominik Mierzejewski <rpm@greysector.net> - 27.0.0-2
- add explicit BR on xsltproc
- fix keyring creation for sig verification with older gpg2 version
- use devtoolset-7 g++ for C++14 support
- skip appstream data validation for now (#1636955)
- don't include man page translations on ppc64 (#1497544)

* Sat Oct 06 2018 Dominik Mierzejewski <rpm@greysector.net> - 27.0.0-1
- update to 27.0.0 (#1636462)
- mkvinfo has no GUI again, moved back to main package
- add missing BR: gcc-c++
- new dependency required to build GUIs: cmark
- disable built-in update check (#1515687)
- verify GPG signature of the source
- requires libmatroska >= 1.4.8
- requires libebml >= 1.3.5
- add Provides: for bundled librmff
- new dependency introduced by upstream (Qt5Multimedia)
- rename desktop files to fix task switcher icons under Wayland
- unbundle json
- clean up prep section
- autogenerate localized files list
- BR docbook-style-xsl and fix check for it
- update Source and main URLs
- add Provides: for bundled avilib
- wxGTK GUI is gone
- use license macro to tag the license text file
- unbundle drake
- drop manual desktop file installation, upstream does it properly now
- unbundle utf8cpp
- remove bundled libebml and libmatroska so that they don't get used
  accidentally if available version is too low

* Thu Sep 29 2016 Richard Shaw <hobbes1069@gmail.com> - 7.4.0-3
- Rebuild after enabling c++11 for pugixml.

* Wed Jul 20 2016 Richard Shaw <hobbes1069@gmail.com> - 7.4.0-2
- Rebuild for new pugixml.

* Wed Dec 17 2014 Dominik Mierzejewski <rpm@greysector.net> 7.4.0-1
- update to 7.4.0
- drop obsolete patch (upstream bug #1090)
- shorten desktop and icon file installation commands
- po4a unavailable on ppc64

* Thu Dec 04 2014 Dominik Mierzejewski <rpm@greysector.net> 7.3.0-1
- update to 7.3.0
- enable unit tests
- use system boost code fragment and pugixml

* Thu Oct 02 2014 Rex Dieter <rdieter@fedoraproject.org> 7.2.0-2
- update icon/mime scriptlets

* Sun Sep 21 2014 Dominik Mierzejewski <rpm@greysector.net> 7.2.0-1
- update to 7.2.0

* Wed Jun 18 2014 Dominik Mierzejewski <rpm@greysector.net> 7.0.0-1
- update to 7.0.0

* Sun Apr 27 2014 Dominik Mierzejewski <rpm@greysector.net> 6.9.1-1
- update to 6.9.1

* Tue Mar 04 2014 Dominik Mierzejewski <rpm@greysector.net> 6.8.0-1
- update to 6.8.0
- fixes bug #1053883

* Sat Jan 18 2014 Dominik Mierzejewski <rpm@greysector.net> 6.7.0-1
- update to 6.7.0

* Fri Dec 27 2013 Dominik Mierzejewski <rpm@greysector.net> 6.6.0-1
- update to 6.6.0
- drop obsolete/redundant specfile parts
- remove executable bit from some sources
- drop version from libmatroska-devel BR
- disable curl support (used only for online update checks)

* Sun Oct 20 2013 Nicolas Chauvet <kwizart@gmail.com> - 6.5.0-1
- Update to 6.5.0
- Fix duplicate localized man pages and add lang(de)

* Thu Oct 03 2013 Nicolas Chauvet <kwizart@gmail.com> - 6.4.1-1
- Update to 6.4.1

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 6.3.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Sat Jul 27 2013 pmachata@redhat.com - 6.3.0-2
- Rebuild for boost 1.54.0

* Sat Jul 13 2013 Nicolas Chauvet <kwizart@gmail.com> - 6.3.0-1
- Update to 6.3.0

* Mon Apr 29 2013 Nicolas Chauvet <kwizart@gmail.com> - 6.2.0-1
- Update to 6.2.0

* Sun Mar 03 2013 Nicolas Chauvet <kwizart@gmail.com> - 6.1.0-1
- Update to 6.1.0

* Fri Feb 22 2013 Nicolas Chauvet <kwizart@gmail.com> - 6.0.0-3
- Rebuilt for f19
- Fix bogus date

* Sat Feb 09 2013 Denis Arnaud <denis.arnaud_fedora@m4x.org> - 6.0.0-2
- Rebuild for Boost-1.53.0

* Tue Jan 22 2013 Nicolas Chauvet <kwizart@gmail.com> - 6.0.0-1
- Update to 6.0.0

* Mon Dec 10 2012 Nicolas Chauvet <kwizart@gmail.com> - 5.9.0-1
- Update to 0.5.9

* Wed Sep 05 2012 Dominik Mierzejewski <rpm@greysector.net> 5.8.0-1
- update to 5.8.0

* Sun Aug 12 2012 Kevin Fenzi <kevin@scrye.com> - 5.7.0-2
- Rebuild for new boost

* Sun Jul 22 2012 Nicolas Chauvet <kwizart@gmail.com> - 5.7.0-1
- Update to 5.7.0

* Fri Jul 20 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.5.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Sun Apr 22 2012 Nicolas Chauvet <kwizart@gmail.com> - 5.5.0-1
- Update to 5.5.0

* Tue Feb 28 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.2.1-3
- Rebuilt for c++ ABI breakage

* Tue Jan 17 2012 Nicolas Chauvet <kwizart@gmail.com> - 5.2.1-2
- Add BR po4a

* Thu Jan 12 2012 Nicolas Chauvet <kwizart@gmail.com> - 5.2.1-1
- Update to 5.2.1
- Add BR libcurl-devel

* Sun Nov 20 2011 Nicolas Chauvet <kwizart@gmail.com> - 5.0.1-1
- Update to 5.0.1

* Fri Sep 09 2011 Dan Horák <dan[at]danny.cz> - 4.9.1-3
- fix boost detection on other 64-bit arches (ax_boost_base.m4 too old)

* Sat Jul 23 2011 Nicolas Chauvet <kwizart@gmail.com> - 4.9.1-2
- Rebuild for boost

* Thu Jul 14 2011 Nicolas Chauvet <kwizart@gmail.com> - 4.9.1-1
- Update to 4.9.1

* Tue Feb 15 2011 Nicolas Chauvet <kwizart@gmail.com> - 4.5.0-1
- Update to 4.5.0
- Backport Fix to build with boost::filesystem3

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.4.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Mon Nov 15 2010 Dominik Mierzejewski <rpm@greysector.net> 4.4.0-1
- updated to 4.4.0
- build system switched to rake -> BR: ruby

* Sun Aug 01 2010 Dominik Mierzejewski <rpm@greysector.net> 4.2.0-1
- updated to 4.2.0 (many bugfixes, see upstream changelog:
  http://www.bunkus.org/cgi-bin/gitweb.cgi?p=mkvtoolnix.git;a=blob;f=ChangeLog)
- sorted BRs alphabetically
- use upstream .desktop files
- install 64x64 icons as well
- drop vendor from desktop filenames
- add Dutch manpages
- process mimeinfo file in scriptlets

* Wed Jul 14 2010 Dan Horák <dan@danny.cz> - 4.0.0-2
- rebuilt against wxGTK-2.8.11-2

* Sat Jun 19 2010 Dominik Mierzejewski <rpm@greysector.net> 4.0.0-1
- updated to 4.0.0

* Sat May 29 2010 Dominik Mierzejewski <rpm@greysector.net> 3.4.0-1
- updated to 3.4.0
- drop unused %%{_datadir}/mkvtoolnix directory
- add build- and runtime requirements on newer libmatroska
- add runtime requirements on newer libebml due to ABI changes

* Sat Mar 27 2010 Dominik Mierzejewski <rpm@greysector.net> 3.3.0-1
- updated to 3.3.0

* Mon Feb 15 2010 Dominik Mierzejewski <rpm@greysector.net> 3.2.0-1
- updated to 3.2.0
- dropped versions from BRs, F-11 has same or newer
- added Chinese manpages

* Sat Jan 23 2010 Dominik Mierzejewski <rpm@greysector.net> 3.1.0-1
- updated to 3.1.0
  * BlueRay subtitles support
- added Japanese manpages

* Fri Jan 22 2010 Rahul Sundaram <sundaram@fedoraproject.org> - 3.0.0-2
- Rebuild for Boost soname bump

* Sat Dec 26 2009 Dominik Mierzejewski <rpm@greysector.net> 3.0.0-1
- updated to 3.0.0
- dropped upstream'd patches

* Sun Dec 06 2009 Dominik Mierzejewski <rpm@greysector.net> 2.9.9-1
- updated to 2.9.9
  * new CLI tool: mkvpropedit
- fixed compilation of vc1parser

* Sun Sep 27 2009 Orcan Ogetbil <oget[DOT]fedora[AT]gmail[DOT]com> 2.9.8-2
- Update desktop file according to F-12 FedoraStudio feature

* Wed Aug 26 2009 Dominik Mierzejewski <rpm@greysector.net> 2.9.8-1
- updated to 2.9.8
- improved summary and description for gui subpackage
- fixed installation of tools

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.6.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Mon Apr 06 2009 Dominik Mierzejewski <rpm@greysector.net> 2.6.0-1
- updated to 2.6.0
- dropped upstreamed patches

* Sun Mar 01 2009 Dominik Mierzejewski <rpm@greysector.net> 2.5.2-1
- updated to 2.5.2
- fix compilation
- include translated messages

* Fri Feb 27 2009 Dominik Mierzejewski <rpm@greysector.net> 2.5.1-1
- updated to 2.5.1
- dropped obsolete patches
- use new icon cache scriptlets
- add missing BR

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.4.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Jan 19 2009 Dominik Mierzejewski <rpm@greysector.net> 2.4.2-1
- updated to 2.4.2
- dropped obsolete boost detection patch
- fixed segmentation fault in mmg (bug #477857)
- backported some minor fixes from current git
- fixed build on ppc64 again

* Wed Dec 17 2008 Benjamin Kosnik  <bkoz@redhat.com> 2.4.0-4
- Rebuild for boost-1.37.0.

* Mon Dec 01 2008 Dominik Mierzejewski <rpm@greysector.net> 2.4.0-3
- dropped obsolete mkvtoolnix-gcc43.patch

* Mon Dec 01 2008 Dominik Mierzejewski <rpm@greysector.net> 2.4.0-2
- fixed boost detection on ppc64 (and sparc64) (bug #473976)

* Sun Nov 30 2008 Dominik Mierzejewski <rpm@greysector.net> 2.4.0-1
- updated to 2.4.0
- rebased patch
- added new BRs
- added missing Requires: hicolor-icon-theme for hicolor icon dirs
- build and include more tools
- fixed rpmlint issues

* Sun Jun 01 2008 Dominik Mierzejewski <rpm@greysector.net> 2.2.0-1
- updated to 2.2.0
- dropped redundant BRs

* Fri Feb 15 2008 Dominik Mierzejewski <rpm@greysector.net> 2.1.0-2
- fixed build with gcc-4.3

* Sun Aug 26 2007 Dominik Mierzejewski <rpm@greysector.net> 2.1.0-1
- updated to 2.1.0
- updated license tag

* Sun Apr 15 2007 Dominik Mierzejewski <rpm@greysector.net> 2.0.2-1
- updated to 2.0.2

* Thu Feb 15 2007 Dominik Mierzejewski <rpm@greysector.net> 2.0.0-1
- updated to 2.0.0
- rebuilt against new flac

* Sat Dec 16 2006 Dominik Mierzejewski <rpm@greysector.net> 1.8.1-2
- rebuilt with new wxGTK

* Tue Dec 05 2006 Dominik Mierzejewski <rpm@greysector.net> 1.8.1-1
- updated to 1.8.1

* Sun Nov 26 2006 Ville Skyttä <ville.skytta at iki.fi> - 1.8.0-3
- Update GTK icon cache in -gui's post(un)install phase, not main pkg's.
- Add menu entry for mkvinfo.

* Thu Nov 23 2006 Dominik Mierzejewski <rpm@greysector.net> 1.8.0-2
- moved mkvinfo and its manpage to -gui
- dropped --enable-debug from configure

* Sun Nov 19 2006 Dominik Mierzejewski <rpm@greysector.net> 1.8.0-1
- updated to 1.8.0
- prevent stripping binaries during make install
- removed sed from BRs
- made -gui Require: current version of the main package
- specfile cleanups

* Fri Jul 28 2006 Dominik Mierzejewski <rpm@greysector.net> 1.7.0-1
- updated to 1.7.0
- removed FCver dependent BRs

* Sun Apr 02 2006 Dominik Mierzejewski <rpm@greysector.net> 1.6.5-3
- added missing BRs
- enable all deps by default

* Sat Jan 07 2006 Dominik Mierzejewski <rpm@greysector.net> 1.6.5-2
- added desktop file and icon for GUI
- remove hardcoded -O3 from configure's CFLAGS

* Fri Jan 06 2006 Dominik Mierzejewski <rpm@greysector.net>
- dropped RH7.x support
- specfile cleanups

* Sun Dec 11 2005 Dominik Mierzejewski <rpm@greysector.net>
- updated to 1.6.5
- updated BuildRequires

* Thu Jul 07 2005 Dominik Mierzejewski <rpm@greysector.net>
- updated to 1.5.0

* Mon Apr 11 2005 Dominik Mierzejewski <rpm@greysector.net>
- fixed BRs for Fedoras

* Wed Jan 12 2005 Dominik Mierzejewski <rpm@greysector.net>
- fixed rebuilding under RH7.3

* Sat Jan 08 2005 Dominik Mierzejewski <rpm@greysector.net>
- updated to 1.0.1

* Sat Oct 16 2004 Dominik Mierzejewski <rpm@greysector.net>
- arranged sections in correct order
- split GUI into separate package
- added some bconds

* Sat Jan 03 2004 Ronald Bultje <rbultje@ronald.bitfreak.net
- set this thing up
